package cc.toph.simplycompat.forge;

import cc.toph.simplycompat.SimplyCompat;
import cc.toph.simplycompat.forge.datagen.DataGeneration;
import dev.architectury.platform.forge.EventBuses;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Optional;

@Mod(SimplyCompat.MOD_ID)
public final class SimplyCompatForge {

    private static final Map<String, IEventBus> EVENT_BUSSES = Collections.synchronizedMap(new HashMap<>());


    @SuppressWarnings("removal")
    public SimplyCompatForge() {
        // Submit our event bus to let Architectury API register our content on the right time.
        var modEventBus = FMLJavaModLoadingContext.get().getModEventBus();
        EventBuses.registerModEventBus(SimplyCompat.MOD_ID, modEventBus);

        // Run our common setup.
        SimplyCompat.init();

        // DataGen Listener
        modEventBus.addListener(DataGeneration::generate);
    }

    public static Optional<IEventBus> getModEventBus(String modId) {
        return Optional.ofNullable(EVENT_BUSSES.get(modId));
    }

}
